<?
/**
 * @author aoksenholt@gmail.com
 *
 * - Lists entries in ttime.entries.txt
 * - Lists entries in chosen database
 *
 * Feel free to modify/improve, but keep footer. I'm happy if you
 * notify me about changes you make. (attach index.php and URL to page
 * in an email).
 *
 */
include ("config.inc");
include ("messages.inc");
if (isset($_GET['language']))
  $language=$_GET['language'];
else
  $language=$DEFAULT_LANG;

$LANG = $language;
$VERSION = "0.16.1";

// requires allow_url_fopen TRUE
//if (isset($_GET['version'])) {
//  print $VERSION;
//  return;
//}
?>

<html>
<head>
<title><?print msg('title');?></title>
<style type="text/css">
body {
  font-family: arial, sans-serif;
  font-size: 12px;
}

table {
  font-size: 12px;
}

table.entries {
  font-size: 13px;
}

table.contents td {
  padding: 2px;
  padding-left: 3px;
  padding-right: 3px;
}
table.contents th {
  padding: 2px;
  padding-left: 3px;
  padding-right: 3px;
}

#footer {
  font-style: italic;
  font-size: 11px;
  padding-top: 20px;
  padding-left: 5px;
}
#lang {
  font-size: 10px;
}
#dlink {
  font-size: 10px;
  margin-top: 5px;
}
</style>

<style type="text/css" media="print">
body {
  margin: 10px;
}

#header {
  display: none;
}
#footer {
  display: none;
}
td {
  padding: 2px;
}
</style>
</head>

<body>
<?
$db_entries = "";

// define arrays to replace norwegian chars
$norwegian = array("","","","","","");
$norEntity = array("&aelig;","&AElig","&oslash;","&Oslash;","&aring;","&Aring;");

init();

function init() {
  global $db_entries;

  $db_entries = setUp();

  // fix for get/post
  $vars = array('a','file','c','preface');
  foreach($vars as $var) {
    if (isset($_POST[$var])) {
      global $$var;
      $$var = $_POST[$var];
    } elseif (isset($_GET[$var])) {
      global $$var;
      $$var = $_GET[$var];
    }
  }

  // get variables
//  $a = $_GET['a'];
//  $file = $_GET['file'];
//  $c = $_GET['c'];
//  $preface = $_GET['preface'];

  if ($a!="" && $file != "") {
    if ($c=="")
      $c=msg('alterativeDbName');
    printEntryList($file,$c);
  } else {
    printDb($db_entries);
  }
}

function setUp() {
  global $DB_FILE;
  
  $db_file_contents = file_get_contents($DB_FILE);
  $db_file_array = split("\n",$db_file_contents);

  //reverse sort array (newest on top)
  rsort($db_file_array);

  return $db_file_array;
}

function printDownloadLink($rv) {
  $changelog="http://folk.ntnu.no/oksenhol/ttime_db/ChangeLog";

  print "<div id=\"dlink\">";
  print "<a href=\"http://folk.ntnu.no/oksenhol/ttime_db/ttimeserver.zip\">";
  
  printf (msg('download'),trim($rv));

  print "</a>&nbsp;-&nbsp;<a href=\"".$changelog."\">view ChangeLog</a>";

  print "</div>";
}

function printLanguages() {
  global $languages;
  global $a;
  global $c;
  global $file;

  print "<div id=\"lang\">";
  foreach ($languages as $key => $value) {
    print "<a href=\"".$PHP_SELF."?language=".$value."\">".$key."</a>&nbsp;&nbsp;";
  }
  print "</div>";
}

function printDb($data) {
  global $norwegian;
  global $norEntity;
  global $showLanguages;
  global $showDownloadLink;
  global $showDbDlLink;
  global $LANG;
  global $VERSION;

  if ($showLanguages)
    printLanguages();
  

  if ($showDownloadLink) {
    $remoteVersion = `wget http://folk.ntnu.no/oksenhol/ttime_db/version.inc -O -`;
    if (trim($remoteVersion) != $VERSION)
      printDownloadLink($remoteVersion);
  }

  print "<h2>".msg('availableLists')."</h2>";
  print msg('firstPageIntro');

  print "<table class=\"contents\" border=\"1\">";
  print "<tr>";
  
  print "<th align=\"center\">".msg('dateHeader')."</th><th align=\"left\">".msg('commentHeader')."</th><th align=\"left\">".msg('numEntriesHeader')."</th><th align=\"left\">".msg('entryListHeader')."</th>";
  
  if ($showDbDlLink)
    print "<th align=\"left\">".msg('downloadDbHeader')."</th>";

  print "</tr>";

  for ($i=0;$i<count($data);$i++) {
    if ($data[$i] != "" && substr($data[$i],0,4)!="http") {
	
      $filename = substr($data[$i],0,14).".csv";
      $numEntries = trim(substr($data[$i],14,7));

      $substrfroment = substr($data[$i],22,strlen($data[$i]));
      $spacepos = strpos($substrfroment," ");
      $substrfroment = substr($substrfroment,$spacepos+1,strlen($data[$i]));
      $spacepos = strpos($substrfroment," ");
      $comment = substr($substrfroment,$spacepos+1,strlen($data[$i]));
      $comment = str_replace($norwegian, $norEntity, $comment);

      $date = substr($filename,6,2).".".substr($filename,4,2).".".substr($filename,0,4);
      $time = substr($filename,8,2).":".substr($filename,10,2).":".substr($filename,12,2);
      print "<tr>";
      print "<td>".$date." ".$time."</td>";
      print "<td>".$comment."</td>";
      print "<td align=\"center\">".$numEntries."</td>";
      print "<td align=\"center\"><a href=\"".$PHP_SELF."?language=".$LANG."&a=showentries&file=".$filename."&c=".urlencode($comment)."&preface=1\">".msg('showListLink')."</a></td>";
      if ($showDbDlLink)
        print "<td align=\"center\"><a href=\"".$filename."\">".msg('showDownloadLink')."</a></td>";
      print "</tr>";
    }
  }
  print "</table>";
  
  printFooter();
}

function printPreface() {
  print "<p class=\"preface\">";

  print msg('preface');

  print "</p>";
}

function printFooter() {
  global $VERSION;
  $changelog="http://folk.ntnu.no/oksenhol/ttime_db/ChangeLog";
  $dl="http://folk.ntnu.no/oksenhol/ttime_db/ttimeserver.zip";


  print "<div id=\"footer\">".msg('dataFrom')." <a href=\"http://ttime.no\">tTiMe</a>";
  print "<br/>".msg('scriptBy')." <a href=\"mailto:aoksenholt-at-gmail.com?subject=ttime-script\">Anders B. &Oslash;ksenholt</a>, <a href=\"".$dl."\">Download script</a><br />";
  print "v. ".$VERSION." <a href=\"".$changelog."\">ChangeLog</a>";
  print "</div>";
}

function printEntryList($f,$comment) {
  global $norwegian;
  global $norEntity;
  global $preface;
  global $INDEX;
  global $LANG;

  $fc = file_get_contents($f);
  $fc_array = split("\n",$fc);

//  printLanguages();

  print "<div id=\"header\">";
  print "<a href='javascript:window.print()'>".msg('print')."</a>";
  print "&nbsp;-&nbsp;";
  if ($preface==1)
    print "<a href=\"".$PHP_SELF."?language=".urlencode($LANG)."&a=showentries&file=".urlencode($f)."&c=".urlencode($comment)."&preface=0\">".msg('dontShowArrInstruction')."</a>";
  else
    print "<a href=\"".$PHP_SELF."?language=".urlencode($LANG)."&a=showentries&file=".urlencode($f)."&c=".urlencode($comment)."&preface=1\">".msg('showArrInstruction')."</a>";
  print "&nbsp;-&nbsp;";
  print "<a href=\"".$INDEX."?language=".$LANG."\">".msg('back')."</a>";
  print "<br/><br/>";
  print "</div>";

  if ($preface==1)
    printPreface();

  print "Database: ".$comment." (".$f.")<br/><br/>";

  print "<table class=\"entries\" border=\"1\">";
  print "<tr>";
  print "<th align=\"left\">".msg('tblIdHeader')."</th>";
  print "<th align=\"center\">".msg('tblEntryHeader')."</th>";
  print "<th align=\"left\">".msg('tblNameHeader')."</th>";
  print "<th align=\"left\">".msg('tblTeamHeader')."</th>";
  print "<th align=\"left\">".msg('tblClassHeader')."</th>";
  print "<th align=\"center\">".msg('tblEcardHeader')."</th>";
  print "<th align=\"center\">".msg('tblNoteHeader')."</th>";
  print "</tr>";

  for ($i=0;$i<count($fc_array);$i++) {
    if ($fc_array[$i] != "") {
      $line = split(";",$fc_array[$i]);
      $line = str_replace($norwegian,$norEntity,$line);      

      print "<tr>";

      print "<td align=\"left\">"; 
      if ($line[0]==""?print "&nbsp;":print $line[0])
      print "</td>";
      
      print "<td align=\"center\">&nbsp;&nbsp;";
      if ($line[1]==""?print "&nbsp;":print $line[1]);
//      print "<td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</td>";
      print "&nbsp;&nbsp;</td>";

      print "<td align=\"left\">".$line[2]."</td>";
      
      print "<td align=\"left\">";
      if ($line[4]==""?print "&nbsp;":print $line[4])
      print "</td>";
      
      print "<td align=\"left\">";
      if ($line[3]==""?print "&nbsp;":print $line[3])
      print "</td>";
      
      print "<td align=\"center\" style=\"width: 70px\">";
      if ($line[6]==""?print "&nbsp;":print $line[6])
      print "</td>";

      // comment field
      print "<td style=\"width: 265px\">&nbsp;</td>";
	
      print "</tr>";
    }
  }  
  
  print "</table>";
  
  printFooter();
}

?>
</body>
</html>
