<?
include ('./config.inc');

/**
 * ttimeserver.php
 * 
 * @author Anders B. ksenholt, aoksenholt@gmail.com
 *
 * PHP-version of Thierry Matthey's ttimeserver.pl
 * For use with tTiMe (http://ttime.no/)
 * 
 * Set path to database and entries in config.inc
 *
 */

/**
 * @param $test_vars array of get or post variabels to check for
 *
 */
function getpost_ifset($test_vars) {
	if (!is_array($test_vars)) {
            $test_vars = array($test_vars);
        }
        
        foreach($test_vars as $test_var) {
            if (isset($_POST[$test_var])) {
                global $$test_var;
                $$test_var = $_POST[$test_var];
            } elseif (isset($_GET[$test_var])) {
                global $$test_var;
                $$test_var = $_GET[$test_var];
            }
        }
} 

/**
 * Check if tTiMe is calling
 * 
 * @return true if tTiMe is calling
 */
function checkAgent() {
	return $_SERVER['HTTP_USER_AGENT']=='tTiMe' ? TRUE : FALSE;
}

/**
 * Check if variable is crap or not
 * 
 * @param variabel to check
 *
 * @return true if $v is fine
 */
function checkVar($v) {
	return (isset($v) && $v!='') ? TRUE : FALSE;
}

/**
 * Get remote ip-address
 * 
 * @return IP if found, otherwise 'unknown'
 */
function getIp() {
	$ip = $_SERVER['REMOTE_ADDR'];

	return strlen($ip) > 1 ? $ip : "unknown";
}

/**
 * Write db-file and append to ttime.entries.txt
 * 
 * @return written data
 */
function writeFiles() {
	global $DBPATH;
	global $DB_FILE;
	global $database;
	global $comment;

	$date = date("YmdGis");
	$datestr = date("Y.m.d G:i:s");
	$arrN = split("\n",$database);
	$n = count($arrN);
	$l = strlen($database);
	$ip = getIp();

	$str = sprintf("%s %6d %s %d %s\n",$date,$n,$ip,$l,$comment);

	$file = $DB_FILE;

	$handle = fopen($file,'a+');
	fwrite($handle,$str);
	fclose($handle);

	$file = $DBPATH.$date.'.csv';
 	$handle = fopen($file,'w+');
	fwrite($handle,$database);
	fclose($handle);
	
	`chmod 755 $file`;

	return $datestr.', '.$comment.', '.$n.', '.$l.', '.$ip;
}

function sendMail($db,$comment) {
	global $EMAIL;

	$to = $EMAIL;
	$subject = $SUBJECT;
	$body = "dette er en test\n".$db."\n".$comment;
	mail($to,$subject,$body);
}

/**
 *
 * Write header and call functions
 * Echos 'Error!' if not valid agent, not valid
 * db and not valid comment
 *
 */
function main() {
	header('Content-type: text/plain');

	global $database;
	global $comment;
	global $SENDMAIL;

	$vars = array('database','comment');
	getpost_ifset($vars);

//	if (checkAgent() && checkVar($database) && checkVar($comment)) {
	if ( checkVar($database) && checkVar($comment)) {
		if ($SENDMAIL)
		  sendMail("",$comment);
		echo writeFiles();
	} else {
		echo $database."<br/>Error!";
	}
}

// call main to start execution
main();

?>
