#!/usr/bin/perl
##
##  printenv -- demo CGI program which just prints its environment
##


print "Content-type: text/plain\n\n";

%in =();
if ($ENV{'REQUEST_METHOD'} eq "GET") {
    $in = $ENV{'QUERY_STRING'};
    @in = split(/&/,$in);       #Splits ordered pairs at the "&" sign
    foreach $i (0 .. $#in) {    #Processes ordered pairs
	# Convert plus's to spaces
	$in[$i] =~ s/\+/ /g;
	# Split into key and value.
	($key, $val) = split(/=/,$in[$i],2); # splits on the first =.
	
	# Convert %XX from hex numbers to alphanumeric
	$key =~ s/%(..)/pack("c",hex($1))/ge;
	$val =~ s/%(..)/pack("c",hex($1))/ge;
	# Associate key and value
	$in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple
	$in{$key} .= $val;                         # separator
    }
} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});	
    $boundary = $ENV{'CONTENT_TYPE'};
    $boundary =~ s/^.+; boundary=//;
    $in =~ s/\r//g;
    $boundary = "--".$boundary;
    @in = split(/\n?$boundary\n*/,$in);
    
    foreach $i (0 .. $#in){
	next if($in[$i] =~ /^\-\-/ || length($in[$i]) < 1);
	($key,$val) = split(/\n\n/,$in[$i],2);
	$key =~ s/^.+ name=\"//;
	$key =~ s/\"$//;
	$in{$key} .= $val;
    }
}
$agent = $ENV{"HTTP_USER_AGENT"};

if($agent ne "tTiMe" || !exists($in{"database"}) || !exists($in{"comment"}) || $in{"database"} eq "" || $in{"comment"} eq ""){
    print "Error!";
    exit;
}



($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =  localtime(time);
#$entries="/home/homep/ok/oksenhol/public_html/ttime_db/ttime.entries.txt";
$entries="/web/folk/oksenhol/ttime_db/ttime.entries.txt";
$date =  sprintf("%02d%02d%02d%02d%02d%02d",$year%100+2000,$mon+1,$mday,$hour,$min,$sec);
$datestr =  sprintf("%02d.%02d.%02d %02d:%02d:%02d",$year%100+2000,$mon+1,$mday,$hour,$min,$sec);
#$file = "/home/homep/ok/oksenhol/public_html/ttime_db/$date.csv";
$file = "/web/folk/oksenhol/ttime_db/$date.csv";

$ipa = $ENV{"REMOTE_ADDR"};
$ipa =~ s/\s//g;
$ipa = "unkonw" if(length($ipa) <1);

$db = $in{"database"};
$comment = $in{"comment"};
(@tmp) = split(/\n/,$db);
$n = $#tmp+1;
$l = length($db);

open(IN,"<$entries");
@oldentreis=<IN>;
close (IN);
$oldentries = join("",@oldentreis);

open(OUT,">$entries");
print(OUT sprintf("$oldentries$date %6d %s %d %s\n",$n,$ipa,$l,$comment));
close(OUT); 

open(OUT,">$file");
print(OUT "$db\n");
close(OUT);
print "$datestr, $comment, $n, $l, $ipa";

$mailprog = '/usr/sbin/sendmail';
$recipient = "";
open (MAIL, "|$mailprog -t $recipient") || die "Can't open $mailprog!\n";
print MAIL "From: Name <$recipient>\n";
print MAIL "To: $recipient\n";
print MAIL "Subject: Upload: $datestr, $comment, $n, $l, $ipa\n\n";

foreach $var (sort(keys(%ENV))) {
    $val = $ENV{$var};
    $val =~ s|\n|\\n|g;
    $val =~ s|"|\\"|g;
    print MAIL "${var}=\"${val}\"\n";
}

close (MAIL);


